<?php
namespace Teknisa\CMP\Controllers;

use \Zeedhi\Framework\DTO\Request;
use \Zeedhi\Framework\DTO\Response;
use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DTO\Response\Error;
use \Zeedhi\Framework\DataSource\DataSet;
use Exception;
use \Teknisa\CMP\Services\ImportacaoAfTxtService;

class ImportacaoAfTxtController extends \Teknisa\GER\Controllers\TeknisaCrud {

  protected $dataSourceName = '';
  protected $crudService;
  protected $connection;
  protected $ImportacaoAfTxtService;

  public function __construct($crudService, $parameterBag, $environment, $ImportacaoAfTxtService) {
    $this->crudService  = $crudService;
    $this->parameterBag = $parameterBag;
    $this->environment = $environment;
    $this->ImportacaoAfTxtService = $ImportacaoAfTxtService;
  }

  public function inclusaoImportacaoAfTxt(Request $request, Response $response) {
    
    $row = $request->getDataSet()->getRows()[0];
    $CDFILIAL = $this->environment->getCdFilial();
    
    try {
      $this->ImportacaoAfTxtService->iniciaConexao();

      //Armazena os dados a serem consumidos
      $cdFilialOL = $row['ARRAY_DATA'][0]['CDFILIAL'];
      $arrayFile = $row['ARRAY_DATA'][0]['FILE']['content'];
      
      //Select na table AUTOFORNE_MOBILE
      $dataNRAUTOFORNE = $this->ImportacaoAfTxtService->selectNRAUTOFORM();
      
      //Passa por cada item inserindo-o na table AUTOFORNE_MOBILE
      foreach($arrayFile as $file){
        foreach($file['ITENS'] as $item){
          $this->ImportacaoAfTxtService->insertItens($dataNRAUTOFORNE[0], $item);
        }
      }

      //Select para verificar possiveis erros na importação de AF
      $selectVD_AUTOFORNE_MOBILE = $this->ImportacaoAfTxtService->selectVD_AUTOFORNE_MOBILE($dataNRAUTOFORNE[0], $arrayFile[0]['ITENS'][0]);

      //SE RETORNAR, RETORNA PARA O FRONT GERAR O RELATÓRIO DE ERROS
      if(count($selectVD_AUTOFORNE_MOBILE) >= 1){
        for($i = 0; $i < count($selectVD_AUTOFORNE_MOBILE); $i++){
          if($selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] === "ERRO_COMPRADOR"){
            $selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] = "Comprador não cadastrado";
          } else if($selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] === "ERRO_FORNECEDOR"){
            $selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] = "Fornecedor não cadastrado";
          } else if($selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] === "ERRO_FILIARQ"){
            $selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] = "Unidade do arquivo difere da Unidade Informada";
          } else if($selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] === "ERRO_FILI_INATIVA"){
            $selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] = "Unidade Inativa";
          } else if($selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] === "ERRO_EXISTE_AF"){
            $selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] = "AF externa já existe no sistema Teknisa";
          } else if($selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] === "ERRO_ARQ_AF_DUPLICADA"){
            $selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] = "AF externa já existe no sistema Teknisa";
          } else if($selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] === "ERRO_FORNE_FILI"){
            $selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] = "Fornecedor não Atende a Unidade";
          } else if($selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] === "ERRO_FORNE_REG"){
            $selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] = "Fornecedor não Atende a Região da Unidade";
          } else if($selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] === "ERRO_PRODUTO"){
            $selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] = "Produto não Cadastrado";
          } else if($selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] === "ERRO_PRODUTO_INATIVO"){
            $selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] = "Produto Inativo";
          } else if($selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] === "ERRO_PROD_INATIVO_FIL"){
            $selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] = "Produto Inativo para a Unidade";
          } else if($selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] === "ERRO_MARCA"){
            $selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] = "Marca não cadastrada";
          } else if($selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] === "ERRO_MARCPROD"){
            $selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] = "Marca não cadastrada para o produto de nível completo";
          } else if($selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] === "ERRO_RELACPRODOL"){
            $selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] = "Produto sem relacionamento de produto do OL";
          } else if($selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] === "ERRO_FORNEPROD"){
            $selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] = "Fornecedor não cadastrado";
          } else if($selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] === "ERRO_PROD_COMPR"){
            $selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] = "Produto de nível completo não cadastrado para o Fornecedor";
          } else if($selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] === "ERRO_DTINV"){
            $selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] = "Data inválida";
          } else if($selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] === "ERRO_QUANT"){
            $selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] = "Quantidade inválida";
          } else if($selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] === "ERRO_VRUNI"){
            $selectVD_AUTOFORNE_MOBILE[$i]['MENSERRO'] = "Preço inválido";
          }
        }
        $response->addDataSet(new DataSet('data', ['error', $selectVD_AUTOFORNE_MOBILE]));
      //Senão executa a procedure "IMP_AUTOFORNE_MOBILE"
      } else {
        $procedure = $this->ImportacaoAfTxtService->procedureIMP_AUTOFORNE_MOBILE($dataNRAUTOFORNE[0], $CDFILIAL);
        $response->addDataSet(new DataSet('data', ['success' ,$procedure]));
      } 
      //Delete dos itens da table AUTOFORNE_MOBILE
      $this->ImportacaoAfTxtService->deleteAUTOFORNEMOBILE($dataNRAUTOFORNE[0]);
      $this->ImportacaoAfTxtService->realizaCommit();
      
    } catch (\Exception $e) {
      $this->ImportacaoAfTxtService->realizaRollback();
      $response->setError(new Error($e->getMessage(), 500));
    }
  }

}