/* Tabela IMPOSERIE: */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na
tabela IMPOSERIE */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela IMPOSERIE, utilizando
a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_FIS_IMPOSERIE
AFTER DELETE OR INSERT OR UPDATE
ON IMPOSERIE FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_DTOPER       DATE;
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   IF DELETING THEN
      IF :OLD.CDIMPOSTO IS NOT NULL THEN
         V_DESC := V_DESC || 'Cod=' || :OLD.CDIMPOSTO;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDEMPRESA || :OLD.CDINSCESTA || :OLD.CDINSCMUNI || :OLD.CDSERIE || :OLD.CDIMPOSTO;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDIMPOSTO <> :NEW.CDIMPOSTO) THEN

            V_TIPO    := '2';
            V_ITPESQ  := :OLD.CDEMPRESA || :OLD.CDINSCESTA || :OLD.CDINSCMUNI || :OLD.CDSERIE || :OLD.CDIMPOSTO;
         END IF;
      ELSE
         V_TIPO       := '1';
         V_ITPESQ     := :NEW.CDEMPRESA || :NEW.CDINSCESTA || :NEW.CDINSCMUNI || :NEW.CDSERIE || :NEW.CDIMPOSTO;
      END IF;

      IF :NEW.CDIMPOSTO IS NOT NULL THEN
         V_DESC := V_DESC || 'Cod=' || :NEW.CDIMPOSTO;
      END IF;

   END IF;
   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;
            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('IMPOSERIE',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR,
                V_DSREMOTEHOST, V_DSSERVMETHOD,
                V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_FIS_IMPOSERIE','4.09.060'); END;
/

