CREATE OR REPLACE TRIGGER LOG_GER_MENSCLIENTE
AFTER UPDATE OR INSERT OR DELETE
ON MENSCLIENTE FOR EACH ROW
DECLARE
  V_TIPO         VARCHAR2(1);
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(500);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
BEGIN
   /*IDTIPOOPER - '1' - Incluso, 
                  '2' - Alterao, 
                  '3' - Excluso*/

   V_TIPO         := '0';
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF DELETING THEN
      IF :OLD.CDCLIENTE IS NOT NULL THEN
         V_DESC := V_DESC || ' CdCliente=' || :OLD.CDCLIENTE;
      END IF;

      IF :OLD.NRMENSCLIENTE IS NOT NULL THEN
         V_DESC := V_DESC || ' NrMensCliente=' || :OLD.NRMENSCLIENTE;
      END IF;

      IF :OLD.CDMENSAGEM IS NOT NULL THEN
         V_DESC := V_DESC || ' CdMensagem=' || :OLD.CDMENSAGEM;
      END IF;

      IF :OLD.IDENTRSAIDMENS IS NOT NULL THEN
         V_DESC := V_DESC || ' IdEntrSaidMens=' || :OLD.IDENTRSAIDMENS;
      END IF;

      IF :OLD.DSMENSCLIENTE IS NOT NULL THEN
         V_DESC := V_DESC || ' DsMensCliente=' || :OLD.DSMENSCLIENTE;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDCLIENTE;
   ELSE
      IF UPDATING THEN
         IF (NVL(:OLD.CDCLIENTE,'!')      <> NVL(:NEW.CDCLIENTE,'!'))      OR
            (NVL(:OLD.NRMENSCLIENTE,'!')  <> NVL(:NEW.NRMENSCLIENTE,'!'))  OR
            (NVL(:OLD.CDMENSAGEM,'!')     <> NVL(:NEW.CDMENSAGEM,'!'))     OR
            (NVL(:OLD.IDENTRSAIDMENS,'!') <> NVL(:NEW.IDENTRSAIDMENS,'!')) OR
            (NVL(:OLD.DSMENSCLIENTE,'!')  <> NVL(:NEW.DSMENSCLIENTE,'!'))  THEN

            IF NVL(:NEW.CDCLIENTE, '!') <> NVL(:OLD.CDCLIENTE, '!') THEN
               V_DESC := V_DESC||' CdCliente='  || :NEW.CDCLIENTE;
            END IF;

            IF NVL(:NEW.NRMENSCLIENTE, '!') <> NVL(:OLD.NRMENSCLIENTE, '!') THEN
               V_DESC := V_DESC||' NrMensCliente='  || :NEW.NRMENSCLIENTE;
            END IF;

            IF NVL(:NEW.CDMENSAGEM, '!') <> NVL(:OLD.CDMENSAGEM, '!') THEN
               V_DESC := V_DESC||' CdMensagem='  || :NEW.CDMENSAGEM;
            END IF;

            IF NVL(:NEW.IDENTRSAIDMENS, '!') <> NVL(:OLD.IDENTRSAIDMENS, '!') THEN
               V_DESC := V_DESC||' IdEntrSaidMens='  || :NEW.IDENTRSAIDMENS;
            END IF;

            IF NVL(:NEW.DSMENSCLIENTE, '!') <> NVL(:OLD.DSMENSCLIENTE, '!') THEN
               V_DESC := V_DESC||' DsMensCliente='  || :NEW.DSMENSCLIENTE;
            END IF;

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDCLIENTE;
         END IF;
      ELSE
         IF NVL(:NEW.CDCLIENTE, '!') <> NVL(:OLD.CDCLIENTE, '!') THEN
            V_DESC := V_DESC||' CdCliente='  || :NEW.CDCLIENTE;
         END IF;

         IF NVL(:NEW.NRMENSCLIENTE, '!') <> NVL(:OLD.NRMENSCLIENTE, '!') THEN
            V_DESC := V_DESC||' NrMensCliente='  || :NEW.NRMENSCLIENTE;
         END IF;

         IF NVL(:NEW.CDMENSAGEM, '!') <> NVL(:OLD.CDMENSAGEM, '!') THEN
            V_DESC := V_DESC||' CdMensagem='  || :NEW.CDMENSAGEM;
         END IF;

         IF NVL(:NEW.IDENTRSAIDMENS, '!') <> NVL(:OLD.IDENTRSAIDMENS, '!') THEN
            V_DESC := V_DESC||' IdEntrSaidMens='  || :NEW.IDENTRSAIDMENS;
         END IF;

         IF NVL(:NEW.DSMENSCLIENTE, '!') <> NVL(:OLD.DSMENSCLIENTE, '!') THEN
            V_DESC := V_DESC||' DsMensCliente='  || :NEW.DSMENSCLIENTE;
         END IF;

         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDCLIENTE;
      END IF;
   END IF;

   V_DESC := SUBSTR(V_DESC, 1, 400);

   IF V_TIPO <> '0' THEN
      IF NOT V_DESC IS NULL THEN
         INSERT INTO LOGOPERA
            (NMTABELA,
             DTOPERACAO,
             NMRESPOPER,
             IDTIPOOPER,
             DSOPERACAO,
             CDPESQITEM,
             DSRDMUSUOPER,
             DSENDUSUOPER,
             DSNMUSUOPER,
             DSMETUSUOPER,
             CDORESPOPER)
         VALUES
            ('MENSCLIENTE',
             SYSDATE,
             NVL(V_NMOPERADOR,' '),
             V_TIPO,
             V_DESC,
             V_ITPESQ,
             V_DSSERVERRDM,
             V_DSREMOTEADDR,
             V_DSREMOTEHOST,
             V_DSSERVMETHOD,
             V_DSREMOTEOPER);
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_MENSCLIENTE','6.00.xxx'); END;
/
